;    guilayout_demo2.pb
;    Version 0.3 [2012/05/05]
;    Copyright (C) 2011 Ronny Krueger
;
;    This file is part of AWPB-Tools.
;
;    AWPB-Tools is free software: you can redistribute it and/or modify
;    it under the terms of the GNU Lesser General Public License as published by
;    the Free Software Foundation, either version 3 of the License, or
;    (at your option) any later version.
;
;    AWPB-Tools is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU Lesser General Public License for more details.
;
;    You should have received a copy of the GNU Lesser General Public License
;    along with AWPB-Tools.  If not, see <http://www.gnu.org/licenses/>.

EnableExplicit

CompilerSelect #PB_Compiler_OS 
  CompilerCase #PB_OS_Windows
    IncludePath "..\include\awpbtools"
  CompilerCase #PB_OS_Linux
    IncludePath "../include/awpbtools"
CompilerEndSelect

XIncludeFile "awguilayout.pbi"

Define win, con0, con1, spl0, gdg0, gdg1, gdg2, gdg3, gdg4
Define *sizerw.AWPB_GUILO_Sizer, *sizerl.AWPB_GUILO_Sizer, *sizerr.AWPB_GUILO_Sizer, s1.i, s2.i, s3.i, lp.i

win = OpenWindow(#PB_Any, 542, 122, 410, 410, "GUI-Layout-Demo 2", #PB_Window_SystemMenu|#PB_Window_SizeGadget|#PB_Window_MinimizeGadget|#PB_Window_TitleBar)
If IsWindow(win)
  con0 = ContainerGadget(#PB_Any, 0, 0, 100, 10, #PB_Container_Single)
  	gdg0 = ButtonGadget(#PB_Any, 0, 0, 100, 10, "first Gadget - 50% width of left side", #PB_Button_MultiLine)
		gdg1 = ButtonGadget(#PB_Any, 0, 0, 100, 10, "second Gadget - 50% width of left side", #PB_Button_MultiLine)
  CloseGadgetList()
  con1 = ContainerGadget(#PB_Any, 0, 0, 100, 10, #PB_Container_Single)
  	gdg2 = ButtonGadget(#PB_Any, 0, 0, 100, 10, "third Gadget - 30% height of right side", #PB_Button_MultiLine)
		gdg3 = ButtonGadget(#PB_Any, 0, 0, 100, 10, "fourth Gadget - 40% height of right side", #PB_Button_MultiLine)
		gdg4 = ButtonGadget(#PB_Any, 0, 0, 100, 10, "fifth Gadget - 30% height of right side", #PB_Button_MultiLine)
  CloseGadgetList()
  spl0 = SplitterGadget(#PB_Any, 0, 1, 100, 10, con0, con1, #PB_Splitter_Separator|#PB_Splitter_Vertical)
  lp   = #PB_Any
  
	*sizerw = AWPB_CreateSizerObj(win)
	If *sizerw
  	*sizerl = AWPB_CreateSizerObj(con0)
  	If *sizerl
    	*sizerr = AWPB_CreateSizerObj(con1)
    	If *sizerr
    	  *sizerw\AddGadget(#Null, spl0, 100)
    	  
    	  s1 = *sizerl\AddSizer(#Null, #AWPB_GUILO_SIZER_HBOX|#AWPB_GUILO_SIZER_REL, 100)
    	       *sizerl\AddGadget(s1, gdg0, 50) 
    	       *sizerl\AddGadget(s1, gdg1, 50)
    	       
    	  s2 = *sizerr\AddSizer(#Null, #AWPB_GUILO_SIZER_VBOX|#AWPB_GUILO_SIZER_REL, 100)
    	       *sizerr\AddGadget(s2, gdg2, 30)
    	       *sizerr\AddGadget(s2, gdg3, 40)
    	       *sizerr\AddGadget(s2, gdg4, 30)
    	       
    	  *sizerw\Finish()
    	  *sizerl\Finish()
    	  *sizerr\Finish()
   	  
    		Repeat
    			Select WaitWindowEvent()
    			  Case #PB_Event_Gadget
    			    Select EventGadget()
    			    	Case spl0
    			    		If lp <> GetGadgetState(spl0)
	        					*sizerw\Resize()
	        					*sizerl\Resize()
	        					*sizerr\Resize()
	        					lp = GetGadgetState(spl0)
	        					Debug lp	
	        				EndIf
        			EndSelect        
    			  Case #PB_Event_SizeWindow
    					*sizerw\Resize()
    					*sizerl\Resize()
    					*sizerr\Resize()
    				Case #PB_Event_CloseWindow
    					Select EventWindow()
    						Case win
    							CloseWindow(win)
    							win = 0
    							Break
    					EndSelect
    			EndSelect
    		ForEver
  
    	  *sizerr\Destroy()
    	Else
    		MessageRequester("Fehler", "Konnte SizerR nicht erstellen")  
    	EndIf
    	*sizerl\Destroy()
  	Else
  		MessageRequester("Fehler", "Konnte SizerL nicht erstellen")  
  	EndIf
    *sizerw\Destroy()
	Else
		MessageRequester("Fehler", "Konnte SizerW nicht erstellen")  
	EndIf
Else
	MessageRequester("Fehler", "Konnte Fenster nicht erstellen")  
EndIf

End


