;    awgdgres.pbi
;    Version 0.1 [2010/09/22]
;    Copyright (C) 2011 Ronny Krueger
;
;    This file is part of AWPB-Tools.
;
;    AWPB-Tools is free software: you can redistribute it and/or modify
;    it under the terms of the GNU Lesser General Public License as published by
;    the Free Software Foundation, either version 3 of the License, or
;    (at your option) any later version.
;
;    AWPB-Tools is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU Lesser General Public License for more details.
;
;    You should have received a copy of the GNU Lesser General Public License
;    along with AWPB-Tools.  If not, see <http://www.gnu.org/licenses/>.

;**
;* awgdgres.pbi_
;* Version 0.1_
;* _
;* Gadget-Resize fr PureBasic 4.50+_
;* Lizenz: LGPL V3_
;* _
;* Systemanforderungen:_
;* <table style="text-align: left;" border="0" cellpadding="2" cellspacing="0"><tbody><tr>
;* <td style="vertical-align: top;">Windows</td><td style="vertical-align: top;">[x]</td>
;* <td style="vertical-align: top;">Linux</td><td style="vertical-align: top;">[x]</td>
;* <td style="vertical-align: top;">Mac</td><td style="vertical-align: top;">[ ]</td></tr><tr>
;* <td style="vertical-align: top;">x86</td><td style="vertical-align: top;">[x]</td>
;* <td style="vertical-align: top;">x64</td><td style="vertical-align: top;">[x]</td>
;* <td style="vertical-align: top;">PPC</td><td style="vertical-align: top;">[ ]</td></tr><tr>
;* <td style="vertical-align: top;">ASCII</td><td style="vertical-align: top;">[x]</td>
;* <td style="vertical-align: top;">Unicode</td><td style="vertical-align: top;">[x]</td>
;* <td style="vertical-align: top;"></td><td style="vertical-align: top;"></td></tr></tbody></table>

;{ private functions
;{ Structures
Structure ____GDG_BaseInfo_Struct
  Gadget.i
  Parent.i
  ParentWidth.i
  ParentHeight.i
  Left.i
  Top.i
  Right.i
  Bottom.i
  Width.i
  Height.i
  Lock_Left.b
  Lock_Top.b
  Lock_Right.b
  Lock_Bottom.b
  HasChildren.b
EndStructure
;}
;{ Variables
NewList ____GDG_ResGdgWin.____GDG_BaseInfo_Struct()
NewList ____GDG_ResGdgCnt.____GDG_BaseInfo_Struct()
;}
;{ Constants
#____GDG_Res_Abs        = 0
#____GDG_Res_Rel        = 1
#____GDG_Res_Prop       = 2
#____GDG_Res_LockWidth  = 3
#____GDG_Res_LockHeight = 4
;}
;{ functions
Procedure   ____GDG_Res_RegGadget_Win(window.i, gadget.i, lockleft.b, locktop.b, lockright.b, lockbottom.b, haschildren.b)
  Shared ____GDG_ResGdgWin()
  
  AddElement(____GDG_ResGdgWin())
  With ____GDG_ResGdgWin()
    \Parent       = window
    \Gadget       = gadget
    \Lock_Left    = lockleft
    \Lock_Top     = locktop
    \Lock_Right   = lockright
    \Lock_Bottom  = lockbottom
    \HasChildren  = haschildren
    \ParentWidth  = WindowWidth(window)
    \ParentHeight = WindowHeight(window)
    \Left         = GadgetX(gadget)
    \Top          = GadgetY(gadget)
    \Width        = GadgetWidth(gadget)
    \Height       = GadgetHeight(gadget)
    \Right        = \ParentWidth - \Width - \Left
    \Bottom       = \ParentHeight - \Height - \Top

  EndWith
EndProcedure
Procedure   ____GDG_Res_RegGadget_Cnt(container.i, gadget.i, lockleft.b, locktop.b, lockright.b, lockbottom.b, haschildren.b)
  Shared ____GDG_ResGdgCnt()
  
  AddElement(____GDG_ResGdgCnt())
  With ____GDG_ResGdgCnt()
    \Parent       = container
    \Gadget       = gadget
    \Lock_Left    = lockleft
    \Lock_Top     = locktop
    \Lock_Right   = lockright
    \Lock_Bottom  = lockbottom
    \HasChildren  = haschildren
    \ParentWidth  = GadgetWidth(container)
    \ParentHeight = GadgetHeight(container)
    \Left         = GadgetX(gadget)
    \Top          = GadgetY(gadget)
    \Width        = GadgetWidth(gadget)
    \Height       = GadgetHeight(gadget)
    \Right        = \ParentWidth - \Width - \Left
    \Bottom       = \ParentHeight - \Height - \Top
  EndWith
EndProcedure
Procedure   ____GDG_Res_UnRegGadget_Cnt(container.i, gadget.i)
  Shared ____GDG_ResGdgCnt()

  ForEach ____GDG_ResGdgCnt()
    If ____GDG_ResGdgCnt()\Parent = container
      If ____GDG_ResGdgCnt()\Gadget = gadget
        DeleteElement(____GDG_ResGdgCnt())
        Break
      EndIf
    EndIf
  Next
EndProcedure
Procedure   ____GDG_Res_UnRegGadget_Win(window.i, gadget.i)
  Shared ____GDG_ResGdgWin()

  ForEach ____GDG_ResGdgWin()
    If ____GDG_ResGdgWin()\Parent = window
      If ____GDG_ResGdgWin()\Gadget = gadget
        DeleteElement(____GDG_ResGdgWin())
        Break
      EndIf
    EndIf
  Next
EndProcedure
Procedure   ____GDG_Res_DoResize_Cnt(container.i)
  Shared ____GDG_ResGdgCnt()
  
  Protected gadget.i, x.i, y.i, w.i, h.i, r.i, b.i
    
  ForEach ____GDG_ResGdgCnt()
    With ____GDG_ResGdgCnt()
      If (\Parent = container) Or (container = #PB_Any)
        gadget    = \Gadget
        container = \Parent
             
        Select \Lock_Left
          Case #____GDG_Res_Abs:       x = \Left
          Case #____GDG_Res_Rel:       x = \Left
          Case #____GDG_Res_Prop:      x = Int((\Left * GadgetWidth(container)) / \ParentWidth)
          Case #____GDG_Res_LockWidth: x = 0
        EndSelect
        Select \Lock_Right
          Case #____GDG_Res_Abs:       r = GadgetWidth(container) - \Left - \Width
          Case #____GDG_Res_Rel:       r = \Right
          Case #____GDG_Res_Prop:      r = Int((\Right * GadgetWidth(container)) / \ParentWidth)
          Case #____GDG_Res_LockWidth: r = 0
        EndSelect        
        
        If \Lock_Left = #____GDG_Res_LockWidth
          w = \Width
          x = GadgetWidth(container) - r - w
        ElseIf \Lock_Right = #____GDG_Res_LockWidth
          w = \Width
        Else
          w = GadgetWidth(container) - r - x
        EndIf
        
        Select \Lock_Top
          Case #____GDG_Res_Abs:        y = \Top
          Case #____GDG_Res_Rel:        y = \Top
          Case #____GDG_Res_Prop:       y = Int((\Top * GadgetHeight(container)) / \ParentHeight)
          Case #____GDG_Res_LockHeight: y = 0
        EndSelect
        Select \Lock_Bottom
          Case #____GDG_Res_Abs:        b = GadgetHeight(container) - \Top - \Height
          Case #____GDG_Res_Rel:        b = \Bottom
          Case #____GDG_Res_Prop:       b = Int((\Bottom * GadgetHeight(container)) / \ParentHeight)
          Case #____GDG_Res_LockHeight: b = 0
        EndSelect
        
        If \Lock_Top = #____GDG_Res_LockHeight
          h = \Height
          y = GadgetHeight(container) - b - h
        ElseIf \Lock_Bottom = #____GDG_Res_LockHeight
          h = \Height
        Else
          h = GadgetHeight(container) - b - y
        EndIf
        
        ResizeGadget(gadget, x, y, w, h)
        
        If \HasChildren : ____GDG_Res_DoResize_Cnt(gadget) : EndIf
      EndIf
    EndWith
  Next
EndProcedure
Procedure   ____GDG_Res_DoResize_Win(window.i)
  Shared ____GDG_ResGdgWin()
  
  Protected gadget.i, x.i, y.i, w.i, h.i, r.i, b.i
    
  ForEach ____GDG_ResGdgWin()
    With ____GDG_ResGdgWin()
      If \Parent = window
        gadget = \Gadget
        
        Select \Lock_Left
          Case #____GDG_Res_Abs:       x = \Left
          Case #____GDG_Res_Rel:       x = \Left
          Case #____GDG_Res_Prop:      x = Int((\Left * WindowWidth(window)) / \ParentWidth)
          Case #____GDG_Res_LockWidth: x = 0
        EndSelect
        Select \Lock_Right
          Case #____GDG_Res_Abs:       r = WindowWidth(window) - \Left - \Width
          Case #____GDG_Res_Rel:       r = \Right
          Case #____GDG_Res_Prop:      r = Int((\Right * WindowWidth(window)) / \ParentWidth)
          Case #____GDG_Res_LockWidth: r = 0
        EndSelect        
        
        If \Lock_Left = #____GDG_Res_LockWidth
          w = \Width
          x = WindowWidth(window) - r - w
        ElseIf \Lock_Right = #____GDG_Res_LockWidth
          w = \Width
        Else
          w = WindowWidth(window) - r - x
        EndIf
        
        Select \Lock_Top
          Case #____GDG_Res_Abs:        y = \Top
          Case #____GDG_Res_Rel:        y = \Top
          Case #____GDG_Res_Prop:       y = Int((\Top * WindowHeight(window)) / \ParentHeight)
          Case #____GDG_Res_LockHeight: y = 0
        EndSelect
        Select \Lock_Bottom
          Case #____GDG_Res_Abs:        b = WindowHeight(window) - \Top - \Height
          Case #____GDG_Res_Rel:        b = \Bottom
          Case #____GDG_Res_Prop:       b = Int((\Bottom * WindowHeight(window)) / \ParentHeight)
          Case #____GDG_Res_LockHeight: b = 0
        EndSelect
        
        If \Lock_Top = #____GDG_Res_LockHeight
          h = \Height
          y = WindowHeight(window) - b - h
        ElseIf \Lock_Bottom = #____GDG_Res_LockHeight
          h = \Height
        Else
          h = WindowHeight(window) - b - y
        EndIf

        ResizeGadget(gadget, x, y, w, h)
        
        ____GDG_Res_DoResize_Cnt(gadget)
      EndIf
    EndWith
  Next
EndProcedure
;}
;}
;{ public functions
;{ constants
#AWPB_GUI_PARENT_WINDOW  = 1                        ;* Parent ist ein Fenster
#AWPB_GUI_PARENT_GADGET  = 2                        ;* Parent ist ein Container-Gadget
#AWPB_GUI_RES_ABS        = #____GDG_Res_Abs         ;* Wert verndert sich nicht
#AWPB_GUI_RES_REL        = #____GDG_Res_Rel         ;* Wert verndert sich absolut zur neuen Fenstergre
#AWPB_GUI_RES_PROP       = #____GDG_Res_Prop        ;* Wert verndert sich proportional zur neuen Fenstergre
#AWPB_GUI_RES_LOCKWIDTH  = #____GDG_Res_LockWidth   ;* Breite wird beibehalten, Position ndert sich bzgl left
#AWPB_GUI_RES_LOCKHEIGHT = #____GDG_Res_LockHeight  ;* Hhe wird beibehalten, Position ndert sich bzgl top
;}
;{ functions
;** awpb_gui_res_reggadget
;* Registriert ein Gadget fr die automatische Grenanpassung._
;* Parent muss das bergeordnete Fenster oder Containergadget sein._
;* Gltige Werte fr Left/Top/Right/Bottom:
;* <ul><li>#AWPB_GUI_RES_ABS - Absolute Position, keine nderung bei resize</li><li>
;* #AWPB_GUI_RES_REL - Feste Position zum Rand des Fensters/Gadgets, Abstand bleibt bei resize gleich</li><li>
;* #AWPB_GUI_RES_PROP - Relative Position, Positionsnderung ist variabel</li><li>
;* #AWPB_GUI_RES_LOCKWIDTH - Breite bleibt fest, Position je nachdem, ob Left oder Right als REL/ABS/PROP definiert ist</li><li>
;* #AWPB_GUI_RES_LOCKHEIGHT - Hhe bleibt fest, Position je nachdem, ob Top oder Bottom als REL/ABS/PROP definiert ist</li></ul>_
;* Wenn es sich um ein Containergadget handelt, das selbst weitere Gadgets enthlt, muss haschildren auf #True gesetzt werden,_
;* sofern diese ebenfalls automatisch resized werden sollen. Ist dies der Fall, so muss dieses Gadget vor allen diesen Gadgets registriert werden.
;** .gadget.i: GadgetID des zur registrierenden Gadgets
;** .left.b: Option fr die linke Position
;** .top.b: Option fr die obere Position
;** .right.b: Option fr die rechte Position
;** .bottom.b: Option fr die untere Position
;** .parent.i: Elternfenster oder Elterngadget (Containergadget)
;** .parenttype.b: Art des Parents_
;* Einer der folgenden Werte:_
;* <ul><li>#AWPB_GUI_PARENT_WINDOW (default)</li><li>#AWPB_GUI_PARENT_GADGET</li></ul>
;** .haschildren.b: wenn es sich um ein Containergadget handelt, das weitere Gadgets beinhaltet auf #True setzen, sonst auf #False lassen
Procedure AWPB_GUI_Res_RegGadget(gadget.i, left.b, top.b, right.b, bottom.b, parent.i, parenttype.b = #AWPB_GUI_PARENT_WINDOW, haschildren.b = #False)
  Select parenttype
    Case #AWPB_GUI_PARENT_WINDOW:
      ____GDG_Res_RegGadget_Win(parent, gadget, left, top, right, bottom, haschildren)
    Case #AWPB_GUI_PARENT_GADGET:
      ____GDG_Res_RegGadget_Cnt(parent, gadget, left, top, right, bottom, haschildren)
  EndSelect
EndProcedure
;** awpb_gui_res_unreggadget
;* Entfernt das Gadget aus der Liste der berwachten Gadgets._
;* Parent muss das bergeordnete Fenster oder Containergadget sein._
;** .gadget.i: GadgetID des zur de-registrierenden Gadgets
;** .parent.i: Elternfenster oder Elterngadget (Containergadget)
;** .parenttype.b: Art des Parents_
;* Einer der folgenden Werte:_
;* <ul><li>#AWPB_GUI_PARENT_WINDOW (default)</li><li>#AWPB_GUI_PARENT_GADGET</li></ul>
Procedure AWPB_GUI_Res_UnRegGadget(gadget.i, parent.i, parenttype.b = #AWPB_GUI_PARENT_WINDOW)
  Select parenttype
    Case #AWPB_GUI_PARENT_WINDOW:
      ____GDG_Res_UnRegGadget_Win(parent, gadget)
    Case #AWPB_GUI_PARENT_GADGET:
      ____GDG_Res_UnRegGadget_Cnt(parent, gadget)
  EndSelect
EndProcedure
;** awpb_gui_res_doresize
;* Frt die Grennderung fr alle Gadgets mit dem bergebenen Parent aus._
;* Falls ein Gadget in dem Parent selber als Parent dient, werden seine Childgadgets ebenfalls resized._
;* Parent muss das bergeordnete Fenster oder Containergadget sein._
;** .parent.i: Elternfenster oder Elterngadget (Containergadget)
;** .parenttype.b: Art des Parents_
;* Einer der folgenden Werte:_
;* <ul><li>#AWPB_GUI_PARENT_WINDOW (default)</li><li>#AWPB_GUI_PARENT_GADGET</li></ul>
Procedure AWPB_GUI_Res_DoResize(parent.i, parenttype.b = #AWPB_GUI_PARENT_WINDOW)
  Select parenttype
    Case #AWPB_GUI_PARENT_WINDOW:
      ____GDG_Res_DoResize_Win(parent)
    Case #AWPB_GUI_PARENT_GADGET:
      ____GDG_Res_DoResize_Cnt(parent)
  EndSelect
EndProcedure
 ;}
 ;}
 

