EnableExplicit
;    awgui.pbi
;    Version 0.1 [2012/04/13]
;    Copyright (C) 2011 Ronny Krueger
;
;    This file is part of AWPB-Tools.
;
;    AWPB-Tools is free software: you can redistribute it and/or modify
;    it under the terms of the GNU Lesser General Public License as published by
;    the Free Software Foundation, either version 3 of the License, or
;    (at your option) any later version.
;
;    AWPB-Tools is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU Lesser General Public License for more details.
;
;    You should have received a copy of the GNU Lesser General Public License
;    along with AWPB-Tools.  If not, see <http://www.gnu.org/licenses/>.

;{ Constants
#AWPB_GUI_SIZER_VBOX      		= 1
#AWPB_GUI_SIZER_HBOX      		= 2
#AWPB_GUI_SIZER_GDG       		= 3
#AWPB_GUI_SIZER_WINDOW    		= 4
#AWPB_GUI_SIZER_CONTAINER		 	= 5
#AWPB_GUI_SIZER_SPACER    		= 6

#AWPB_GUI_SIZER_ALIGN_TOP			= $00000001
#AWPB_GUI_SIZER_ALIGN_LEFT		= $00000002
#AWPB_GUI_SIZER_ALIGN_RIGHT		= $00000004
#AWPB_GUI_SIZER_ALIGN_BOTTOM	= $00000008
#AWPB_GUI_SIZER_ALIGN_CENTER	= $0000000F
;}
;{ Gadget Callback Prototypes
Enumeration
	#AWPB_GUI_None
	#AWPB_GUI_OnClicked
	#AWPB_GUI_OnBeforeResize
	#AWPB_GUI_OnAfterResize
	
EndEnumeration

; *Gadget is *AWPB_GUI_Gadget
PrototypeC AWPB_GUI_OnClicked_Proto(*Gadget)
PrototypeC AWPB_GUI_OnBeforeResize_Proto(*Gadget)
PrototypeC AWPB_GUI_OnAfterResize_Proto(*Gadget)


;}
;{ GadgetInfo Structures
Structure ____AWPB_GUI_GadgetInfoBase
	; private Attributes
	_Gadget.i
	_Type.i
	
	; public Attributes
	Left.i
	Top.i
	Width.i
	Height.i	
	
	BorderLeft.i		
	BorderTop.i
	BorderRight.i
	BorderBottom.i
	
	MinWidth.i			
	MinHeight.i
	MaxWidth.i
	MaxHeight.i
	
	Align.i
	
	; Event Callbacks
	*OnBeforeResize.AWPB_GUI_OnBeforeResize_Proto
	*OnAfterResize.AWPB_GUI_OnAfterResize_Proto
	
EndStructure
Structure AWPB_GUI_ButtonInfo Extends ____AWPB_GUI_GadgetInfoBase
	; public Attributes
	Text.s
	Flags.i
	
	; Event Callbacks
	*OnClicked.AWPB_GUI_OnClicked_Proto
EndStructure	
Procedure AWPB_GUI_SetGadgetInfoDefaults(*GdgInfo.____AWPB_GUI_GadgetInfoBase)
	ClearStructure(*GdgInfo, ____AWPB_GUI_GadgetInfoBase)
	With *GdgInfo
		\MinWidth		= #PB_Any
		\MinHeight	= #PB_Any
		\MaxWidth		= #PB_Any
		\MaxHeight	= #PB_Any
		\Align			= #AWPB_GUI_SIZER_ALIGN_CENTER
	EndWith
EndProcedure
;}
;{ AWPB_GUI_Gadget
Interface AWPB_GUI_Gadget
	Gadget.i			()
	Type.i				()
	GadgetInfo.i	()
	_Destroy			()
	_Finish.b			()
EndInterface
Structure ____AWPB_GUI_Gadget
	*vt.____AWPB_GUI_Gadget_VT	
	StructureUnion
		Base.____AWPB_GUI_GadgetInfoBase
		Button.AWPB_GUI_ButtonInfo
		
		;- Additional Gadgets
	EndStructureUnion
EndStructure

Procedure.i ____AWPB_CreateGadgetObj(*GadgetInfo.____AWPB_GUI_GadgetInfoBase)
	Protected *this.____AWPB_GUI_Gadget
  	
	*this = AllocateMemory(SizeOf(____AWPB_GUI_Gadget))
	If *this 
		InitializeStructure(*this, ____AWPB_GUI_Gadget)
		*this\vt 							  	= ?____AWPB_GUI_Gadget_VT
		*this\Base\_Gadget		  	= #Null
		*this\Base\_Type					= *GadgetInfo\_Type
		*this\Base\BorderBottom		= *GadgetInfo\BorderBottom
		*this\Base\BorderLeft  		= *GadgetInfo\BorderLeft
		*this\Base\BorderTop			= *GadgetInfo\BorderTop
		*this\Base\BorderRight		= *GadgetInfo\BorderRight
		*this\Base\Left						= *GadgetInfo\Left
		*this\Base\Top						= *GadgetInfo\Top
		*this\Base\Width					= *GadgetInfo\Width
		*this\Base\Height					= *GadgetInfo\Height
		*this\Base\OnAfterResize	= *GadgetInfo\OnAfterResize
		*this\Base\OnBeforeResize	= *GadgetInfo\OnBeforeResize
		
		Select *GadgetInfo\_Type
			Case #PB_GadgetType_Button
				With *this\Button
					Protected *Gdg.AWPB_GUI_ButtonInfo = *GadgetInfo
					
					\Flags 			= *Gdg\Flags
					\Text	 			= *Gdg\Text
					\OnClicked	= *Gdg\OnClicked
					
					
				;- Gadget Initialization	
					
				EndWith
				
		EndSelect
		
		ProcedureReturn *this
	EndIf
	
	ProcedureReturn #Null
EndProcedure
Procedure   ____AWPB_GUI_Gadget__Destroy(*this.____AWPB_GUI_Gadget)
	FreeMemory(*this)
EndProcedure
Procedure.b ____AWPB_GUI_Gadget__Finish(*this.____AWPB_GUI_Gadget)
	Select *this\Base\_Type
		Case #PB_GadgetType_Button
			With *this\Button
				\_Gadget = ButtonGadget(#PB_Any, \Left, \Top, \Width, \Height, \Text, \Flags)
			EndWith
				
							;- Gadget Creation
				
	EndSelect

	
	
	If IsGadget(*this\Base\_Gadget)
		ProcedureReturn #True
	EndIf
	
	ProcedureReturn #False
EndProcedure
Procedure.i ____AWPB_GUI_Gadget_Gadget(*this.____AWPB_GUI_Gadget)
	ProcedureReturn *this\Base\_Gadget
EndProcedure
Procedure.i ____AWPB_GUI_Gadget_Type(*this.____AWPB_GUI_Gadget)
	ProcedureReturn *this\Base\_Type
EndProcedure
Procedure.i ____AWPB_GUI_Gadget_GadgetInfo(*this.____AWPB_GUI_Gadget)
	ProcedureReturn @*this\Base
EndProcedure

DataSection ;{
____AWPB_GUI_Gadget_VT:
	Data.i @____AWPB_GUI_Gadget_Gadget()
	Data.i @____AWPB_GUI_Gadget_Type()
	Data.i @____AWPB_GUI_Gadget_GadgetInfo()
  Data.i @____AWPB_GUI_Gadget__Destroy()
  Data.i @____AWPB_GUI_Gadget__Finish()
EndDataSection ;}
;}
;{ AWPB_GUI_Sizer

Interface AWPB_GUI_Sizer
	AddSizer.i   	(*ParentSizer, Type.b, Mode.b, Size.i)
	AddGadget.b  	(*ParentSizer, *GadgetInfo, Mode.b, Size.i)
	AddSpacer.b	 	(*ParentSizer, Mode.b, Size.i)
	_Initialize.b	(ParentID.i)
	_Destroy     	()
	_Finish	     	(ExecuteBeforeResizeCallbacks.b, ExecuteAfterResizeCallbacks.b)
	_Resize      	(ExecuteBeforeResizeCallbacks.b, ExecuteAfterResizeCallbacks.b)
	_MinWidth.i  	(ParentSizer.i = #Null)
	_MinHeight.i 	(ParentSizer.i = #Null)
EndInterface
Structure ____AWPB_GUI_Sizer_Data
	; calculated values
	l.i
	t.i
	r.i
	b.i
	w.i
	h.i
	
	; given values
	StructureUnion
		*Gadget.AWPB_GUI_Gadget
		*GadgetData.____AWPB_GUI_Gadget
	EndStructureUnion
	Type.b
	Mode.b
	Size.i
	
	List *childs.____AWPB_GUI_Sizer_Data()
EndStructure
Structure ____AWPB_GUI_Sizer
	*vt.____AWPB_GUI_Sizer_VT
	
	sizers.____AWPB_GUI_Sizer_Data
	
	Parent.i
	ParentType.b
EndStructure

Procedure.i ____AWPB_CreateSizerObj(ParentType.b = #AWPB_GUI_SIZER_WINDOW)
	Protected *this.____AWPB_GUI_Sizer
	
	*this = AllocateMemory(SizeOf(____AWPB_GUI_Sizer))
	If *this 
 		InitializeStructure(*this, ____AWPB_GUI_Sizer)
 		*this\vt            = ?____AWPB_GUI_Sizer_VT
 		*this\sizers\l			= 0
 		*this\sizers\t			= 0
 		*this\ParentType		= ParentType
 		*this\Parent				= #Null
 		*this\sizers\Gadget	= #Null
 		*this\sizers\Type   = #AWPB_GUI_SIZER_VBOX
		*this\sizers\Size   = 100
		
		ProcedureReturn *this
	EndIf
	
	ProcedureReturn #Null
EndProcedure
Procedure.b	____AWPB_GUI_Sizer__Initialize(*this.____AWPB_GUI_Sizer, ParentID.i)
	Select *this\ParentType
	  Case #AWPB_GUI_SIZER_WINDOW
	    If Not IsWindow(ParentID) 
	      ProcedureReturn #False
	    EndIf
      *this\sizers\r = WindowWidth(ParentID)
      *this\sizers\b = WindowHeight(ParentID)	    
	  Case #AWPB_GUI_SIZER_CONTAINER
	    If Not IsGadget(ParentID)
	      ProcedureReturn #False
	    EndIf
      *this\sizers\r = GadgetWidth(ParentID)
      *this\sizers\b = GadgetHeight(ParentID)	  
    Default
    	ProcedureReturn #False
	EndSelect
	*this\Parent 		= ParentID
	*this\sizers\w  = *this\sizers\r
	*this\sizers\h  = *this\sizers\b
	
	ProcedureReturn #True
EndProcedure
Procedure   ____AWPB_GUI_Sizer__DestroyChild(*sizer.____AWPB_GUI_Sizer_Data)
	ForEach *sizer\childs()
		____AWPB_GUI_Sizer__DestroyChild(*sizer\childs())
	Next
	FreeList(*sizer\childs())
	If *sizer\Gadget
		*sizer\Gadget\_Destroy()
	EndIf
	FreeMemory(*sizer)
EndProcedure
Procedure   ____AWPB_GUI_Sizer__Destroy(*this.____AWPB_GUI_Sizer)
	ForEach *this\sizers\childs()
		____AWPB_GUI_Sizer__DestroyChild(*this\sizers\childs())
	Next
	FreeList(*this\sizers\childs())
	If *this\sizers\Gadget
		*this\sizers\Gadget\_Destroy()
	EndIf
	FreeMemory(*this)
EndProcedure
Procedure   ____AWPB_GUI_Sizer__FinishChild(*sizer.____AWPB_GUI_Sizer_Data, ExecuteBeforeResizeCallbacks.b, ExecuteAfterResizeCallbacks.b)
	Protected l.i, t.i, r.i, b.i, w.i, h.i, gl.i, gt.i, gb.i, gr.i, gw.i, gh.i, ol.i, ot.i, ow.i, oh.i
	
	l = *sizer\l
	t = *sizer\t
	r = *sizer\r
	b = *sizer\b
	w = *sizer\w
	h = *sizer\h
	
	If *sizer\type = #AWPB_GUI_SIZER_GDG
		If *sizer\Gadget <> #Null
		  ol = l
		  ot = t
		  ow = w
		  oh = h
		  gl = *sizer\l + *sizer\GadgetData\Base\BorderLeft
		  gt = *sizer\t + *sizer\GadgetData\Base\BorderTop
		  gr = *sizer\r - *sizer\GadgetData\Base\BorderRight
			gb = *sizer\b - *sizer\GadgetData\Base\BorderBottom
			If gl > gr : gl = *sizer\l : EndIf
			If gt > gb : gl = *sizer\t : EndIf
			If gr < gl : gr = *sizer\r : EndIf
			If gb < gt : gb = *sizer\b : EndIf
			gw = gr - gl
			gh = gb - gt 
	    If (l <> ol) Or (t <> ot) Or (gw <> ow) Or (gh <> oh)
	  		If ExecuteBeforeResizeCallbacks 
	  			If *sizer\GadgetData\Base\OnBeforeResize <> #Null
			      *sizer\GadgetData\Base\OnBeforeResize(*sizer\Gadget)
			    EndIf  
			  EndIf  
  			ResizeGadget(*sizer\GadgetData\Base\_Gadget, gl, gt, gw, gh)
	  		If ExecuteAfterResizeCallbacks 
		  	  If *sizer\GadgetData\Base\OnAfterResize <> #Null
			      *sizer\GadgetData\Base\OnAfterResize(*sizer\Gadget)
			    EndIf  
			  EndIf  
			EndIf
		EndIf
	ElseIf *sizer\type = #AWPB_GUI_SIZER_SPACER
	  ;- TODO
	  
  Else
		ForEach *sizer\childs()
			With *sizer\childs()
				If *sizer\type = #AWPB_GUI_SIZER_HBOX
					; horizontal - t, b and h static
					\t = t
					\b = b
					\h = h
					\l = l
					\w = (w * \size) / 100	; size in % of available parent
					\r = \l + \w - 1
					l  = \r + 1
				ElseIf *sizer\type = #AWPB_GUI_SIZER_VBOX
					; vertical - l, r and w static
					\l = l
					\r = r
					\w = w
					\t = t
					\h = (h * \size) / 100
					\b = \t + \h - 1
					t  = \b + 1
				EndIf
			EndWith
			____AWPB_GUI_Sizer__FinishChild(*sizer\childs(), ExecuteBeforeResizeCallbacks, ExecuteAfterResizeCallbacks)
		Next
	EndIf
EndProcedure
Procedure   ____AWPB_GUI_Sizer__Finish(*this.____AWPB_GUI_Sizer, ExecuteBeforeResizeCallbacks.b, ExecuteAfterResizeCallbacks.b)
	____AWPB_GUI_Sizer__FinishChild(@*this\sizers, ExecuteBeforeResizeCallbacks, ExecuteAfterResizeCallbacks)
EndProcedure
Procedure   ____AWPB_GUI_Sizer__Resize(*this.____AWPB_GUI_Sizer, ExecuteBeforeResizeCallbacks.b, ExecuteAfterResizeCallbacks.b)
  Select *this\parenttype
    Case #AWPB_GUI_SIZER_WINDOW
      *this\sizers\r        = WindowWidth(*this\Parent)
      *this\sizers\b        = WindowHeight(*this\Parent)
    Case #AWPB_GUI_SIZER_CONTAINER
      *this\sizers\r        = GadgetWidth(*this\Parent)
      *this\sizers\b        = GadgetHeight(*this\Parent)
	EndSelect
	*this\sizers\w = *this\sizers\r
	*this\sizers\h = *this\sizers\b
	____AWPB_GUI_Sizer__Finish(*this, ExecuteBeforeResizeCallbacks, ExecuteAfterResizeCallbacks)
EndProcedure
Procedure.b ____AWPB_GUI_Sizer_AddGadget(*this.____AWPB_GUI_Sizer, *ParentSizer.____AWPB_GUI_Sizer_Data, *GadgetInfo.____AWPB_GUI_GadgetInfoBase, Size.i)
	Protected *sizer.____AWPB_GUI_Sizer_Data
	
	If *GadgetInfo <> #Null
		*sizer = AllocateMemory(SizeOf(____AWPB_GUI_Sizer_Data))
		If *sizer
			InitializeStructure(*sizer, ____AWPB_GUI_Sizer_Data)
			*sizer\Gadget = ____AWPB_CreateGadgetObj(*GadgetInfo)
			With *sizer
				\Type     			= #AWPB_GUI_SIZER_GDG
				\Size     			= Size
			EndWith
			
			If *ParentSizer
				AddElement(*ParentSizer\childs())
				*ParentSizer\childs() = *sizer
			Else
				AddElement(*this\sizers\childs())
				*this\sizers\childs() = *sizer
			EndIf
			
			ProcedureReturn #True
		EndIf
	EndIf
	
	ProcedureReturn #False
EndProcedure
Procedure.i ____AWPB_GUI_Sizer_AddSizer(*this.____AWPB_GUI_Sizer, *ParentSizer.____AWPB_GUI_Sizer_Data, Type.b, Size.i)
	Protected *sizer.____AWPB_GUI_Sizer_Data
	
	*sizer = AllocateMemory(SizeOf(____AWPB_GUI_Sizer_Data))
	If *sizer
		InitializeStructure(*sizer, ____AWPB_GUI_Sizer_Data)
		With *sizer
			\Type 	= Type
			\Size 	= Size
			\Gadget = #Null
		EndWith
		
		If *ParentSizer
			AddElement(*ParentSizer\childs())
			*ParentSizer\childs() = *sizer
		Else
			AddElement(*this\sizers\childs())
			*this\sizers\childs() = *sizer
		EndIf
	EndIf
	
	ProcedureReturn *sizer		
EndProcedure
Procedure   ____AWPB_GUI_Sizer_AddSpacer(*this.____AWPB_GUI_Sizer, *ParentSizer.____AWPB_GUI_Sizer_Data, Size.i)
	Protected *sizer.____AWPB_GUI_Sizer_Data
	
	*sizer = AllocateMemory(SizeOf(____AWPB_GUI_Sizer_Data))
	If *sizer
		InitializeStructure(*sizer, ____AWPB_GUI_Sizer_Data)
		With *sizer
			\Type   = #AWPB_GUI_SIZER_SPACER
			\Size   = Size
			\Gadget = #Null
		EndWith
		
		If *ParentSizer
			AddElement(*ParentSizer\childs())
			*ParentSizer\childs() = *sizer
		Else
			AddElement(*this\sizers\childs())
			*this\sizers\childs() = *sizer
		EndIf
		
		ProcedureReturn #True
	EndIf
	
	ProcedureReturn #False
EndProcedure
Procedure.i ____AWPB_GUI_Sizer__MinWidth(*this.____AWPB_GUI_Sizer, *ParentSizer.____AWPB_GUI_Sizer_Data = #Null)
	;- TODO
	
EndProcedure
Procedure.i ____AWPB_GUI_Sizer__MinHeight(*this.____AWPB_GUI_Sizer, *ParentSizer.____AWPB_GUI_Sizer_Data = #Null)
	;- TODO
	
EndProcedure

DataSection ;{
____AWPB_GUI_Sizer_VT:
  Data.i @____AWPB_GUI_Sizer_AddSizer()
  Data.i @____AWPB_GUI_Sizer_AddGadget()
  Data.i @____AWPB_GUI_Sizer_AddSpacer()
  Data.i @____AWPB_GUI_Sizer__Initialize()
  Data.i @____AWPB_GUI_Sizer__Destroy()
  Data.i @____AWPB_GUI_Sizer__Finish()
  Data.i @____AWPB_GUI_Sizer__Resize()
  Data.i @____AWPB_GUI_Sizer__MinWidth()
  Data.i @____AWPB_GUI_Sizer__MinHeight()  
EndDataSection ;}
;}


; ;{ AWPB_GUI_Window
; Interface AWPB_GUI_Window
; 	Destroy			()
; 	
; 	
; 	
; 	
; 	Finish	    (ExecuteBeforeResizeCallbacks.b = #False, ExecuteAfterResizeCallbacks.b = #False)
; 	Resize      (ExecuteBeforeResizeCallbacks.b = #False, ExecuteAfterResizeCallbacks.b = #False)
; 	AddSizer.i  (Type.b = #AWPB_GUI_SIZER_VBOX) ; #Null, #AWPB_GUI_SIZER_HBOX, #AWPB_GUI_SIZER_REL, 100
; 	MinWidth.i  () ; ParentSizer.i = #Null
; 	MinHeight.i () ; ParentSizer.i = #Null
; EndInterface
; Structure ____AWPB_GUI_Window
; 	*vt.____AWPB_GUI_Window_VT
; 	*sizer.AWPB_GUI_Sizer
; EndStructure
; Procedure.i ____AWPB_CreateWindowObj()
; 	Protected *this.____AWPB_GUI_Window
;   	
; 	*this = AllocateMemory(SizeOf(____AWPB_GUI_Window))
; 	If *this 
; 		InitializeStructure(*this, ____AWPB_GUI_Window)
; 		*this\vt              = ?____AWPB_GUI_Window_VT
; 		*this\sizer           = AWPB_CreateSizerObjLazy()
; 		If *this\sizer
; 			
; 		Select ParentType
; 	    Case #AWPB_GUI_SIZER_WINDOW
; 	      *this\sizers\r        = WindowWidth(ParentID)
; 	      *this\sizers\b        = WindowHeight(ParentID)
; 	    Case #AWPB_GUI_SIZER_CONTAINER
; 	      *this\sizers\r        = GadgetWidth(ParentID)
; 	      *this\sizers\b        = GadgetHeight(ParentID)
; 		EndSelect
; 		*this\sizers\w        			= *this\sizers\r
; 		*this\sizers\h        			= *this\sizers\b
; 		*this\sizers\bleft   			  = 0
; 		*this\sizers\btop    			  = 0
; 		*this\sizers\bright   			= 0
; 		*this\sizers\bbottom  			= 0
; 		*this\sizers\GadgetID 			= #PB_Any
; 		*this\sizers\type     			= #AWPB_GUI_SIZER_VBOX
; 		*this\sizers\mode     			= #AWPB_GUI_SIZER_REL
; 		*this\sizers\size     			= 100
; 		*this\sizers\OnBeforeResize = #Null
; 		*this\sizers\OnAfterResize  = #Null
; 		
; 		ProcedureReturn *this
; 	EndIf
; 	
; 	ProcedureReturn #Null
; EndProcedure
; Procedure   ____AWPB_GUI_Sizer_DestroyChild(*sizer.____AWPB_GUI_Sizer_Data)
; 	ForEach *sizer\childs()
; 		____AWPB_GUI_Sizer_DestroyChild(*sizer\childs())
; 	Next
; 	FreeList(*sizer\childs())
; 	FreeMemory(*sizer)
; EndProcedure
; Procedure   ____AWPB_GUI_Sizer_Destroy(*this.____AWPB_GUI_Sizer)
; 	ForEach *this\sizers\childs()
; 		____AWPB_GUI_Sizer_DestroyChild(*this\sizers\childs())
; 	Next
; 	FreeList(*this\sizers\childs())
; 	FreeMemory(*this)
; EndProcedure
; 
; 
; 
; 
; 
; 
; 
; DataSection ;{
; ____AWPB_GUI_Window_VT:
;   Data.i @____AWPB_GUI_Window_Destroy()
;   Data.i @____AWPB_GUI_Windw_Finish()
;   Data.i @____AWPB_GUI_Sizer_Resize()
;   Data.i @____AWPB_GUI_Sizer_AddGadget()
;   Data.i @____AWPB_GUI_Sizer_AddSizer()
;   Data.i @____AWPB_GUI_Sizer_MinWidth()
;   Data.i @____AWPB_GUI_Sizer_MinHeight()  
; EndDataSection ;}
; ;}

