;    awsqlstatement.pbi
;    Version 0.1 [2012/04/27]
;    Copyright (C) 2012 Ronny Krueger
;
;    This file is part of AWPB-Tools.
;
;    AWPB-Tools is free software: you can redistribute it and/or modify
;    it under the terms of the GNU Lesser General Public License as published by
;    the Free Software Foundation, either version 3 of the License, or
;    (at your option) any later version.
;
;    AWPB-Tools is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU Lesser General Public License for more details.
;
;    You should have received a copy of the GNU Lesser General Public License
;    along with AWPB-Tools.  If not, see <http://www.gnu.org/licenses/>.

;{ SQLStatement-Object
Interface AWPB_SQLStatement
  Destroy    ()
  SetSQL     (sqlcmd.s)
  BindQuad   (index.i, value.q)
  BindLong   (index.i, value.l)
  BindFloat  (index.i, value.f)
  BindDouble (index.i, value.d)
  BindString (index.i, value.s)
  GetSQL.s   ()
  Reset      ()
EndInterface
Structure ____AWPB_SQLStatement
  *vt.AWPB_SQLStatement
  Map bound.s()
  sql.s
  compiled.s
EndStructure
Procedure.i AWPB_CreateSQLStatementObj()
  Protected *this.____AWPB_SQLStatement
  
  *this = AllocateMemory(SizeOf(____AWPB_SQLStatement))
  If *this 
    InitializeStructure(*this, ____AWPB_SQLStatement)
    *this\vt       = ?____AWPB_SQLStatement_VT
    *this\sql      = ""
    *this\compiled = ""
    
    ProcedureReturn *this
  EndIf
  
  ProcedureReturn #Null
EndProcedure
Procedure.i ____AWPB_SQLStatement_Destroy(*this.____AWPB_SQLStatement)
  ClearMap(*this\bound())
  FreeMemory(*this)
  ProcedureReturn #Null
EndProcedure
Procedure   ____AWPB_SQLStatement_SetSQL(*this.____AWPB_SQLStatement, sqlcmd.s)
  *this\sql      = sqlcmd
  *this\compiled = ""
EndProcedure 
Procedure   ____AWPB_SQLStatement_BindQuad(*this.____AWPB_SQLStatement, index.i, value.q)
  *this\bound(Str(index)) = Str(value)
EndProcedure
Procedure   ____AWPB_SQLStatement_BindLong(*this.____AWPB_SQLStatement, index.i, value.l)
  *this\bound(Str(index)) = Str(value)
EndProcedure
Procedure   ____AWPB_SQLStatement_BindFloat(*this.____AWPB_SQLStatement, index.i, value.f)
  *this\bound(Str(index)) = StrF(value)
EndProcedure
Procedure   ____AWPB_SQLStatement_BindDouble(*this.____AWPB_SQLStatement, index.i, value.d)
  *this\bound(Str(index)) = StrD(value)
EndProcedure
Procedure   ____AWPB_SQLStatement_BindString(*this.____AWPB_SQLStatement, index.i, value.s)
  *this\bound(Str(index)) = Chr(34) + ReplaceString(value, Chr(34), Chr(34)+Chr(34)) + Chr(34)
EndProcedure
Procedure.s ____AWPB_SQLStatement_GetSQL(*this.____AWPB_SQLStatement)
  Protected k.i, c.i
  
  *this\compiled = ""
  c              = CountString(*this\sql, "?")

  For k = 1 To c + 1
    *this\compiled + StringField(*this\sql, k, "?")
    If k <= c : *this\compiled + *this\bound(Str(k)) : EndIf
  Next k
  
  ProcedureReturn *this\compiled
EndProcedure
Procedure   ____AWPB_SQLStatement_Reset(*this.____AWPB_SQLStatement)
  ClearMap(*this\bound())
  *this\compiled = ""
EndProcedure
DataSection ;{
____AWPB_SQLStatement_VT:
  Data.i @____AWPB_SQLStatement_Destroy()
  Data.i @____AWPB_SQLStatement_SetSQL()
  Data.i @____AWPB_SQLStatement_BindQuad()
  Data.i @____AWPB_SQLStatement_BindLong()
  Data.i @____AWPB_SQLStatement_BindFloat()
  Data.i @____AWPB_SQLStatement_BindDouble()
  Data.i @____AWPB_SQLStatement_BindString()
  Data.i @____AWPB_SQLStatement_GetSQL()
  Data.i @____AWPB_SQLStatement_Reset()
EndDataSection ;}
;}

